#include "HLS/hls.h"
#include <stdio.h>
#include "simple_counter.h"

using namespace ihc;

int main() {
  constexpr int SIZE = 100;
  unsigned int result[SIZE];

  // Component call phase
  for(unsigned int i=0; i<SIZE; ++i) {
    ihc_hls_enqueue(&result[i], &simple_counter);
  }

  ihc_hls_component_run_all(simple_counter);

  bool pass = true;

  // Verification phase
  for(unsigned int i=0; i < SIZE; ++i) {
    if (result[i] != i) {
      printf("ERROR: Expected %u, found %u\n", i, result[i]);
      pass = false;
    }
  }

  if (pass) {
    printf("PASSED\n");
  }
  else {
    printf("FAILED\n");
  }

  return 0;

}
